package main

import (
	"testing"

	"report/graph"
	"report/graph/model"

	"github.com/99designs/gqlgen/client"
	"github.com/99designs/gqlgen/graphql/handler"
)

func Test_GQL(t *testing.T) {
	srv := handler.NewDefaultServer(
		graph.NewExecutableSchema(
			graph.Config{Resolvers: &graph.Resolver{}},
		),
	)
	query := `
        mutation addTodo {
            createTodo(input: {text: "test", date: "2024-02-02T12:00:00Z"}) {
                text
                date
            }
        } `
	var resp struct {
		CreateTodo model.Todo `json:"createTodo"`
	}

	err := client.
		New(srv).
		Post(query, &resp)
	if err != nil {
		t.Fatalf("unexpected error: %v", err)
	}

	if resp.CreateTodo.Date.String() != "2024-02-02T12:00:00Z" {
		t.Errorf("date did not match")
	}
}
